









                            ENHDEMO v1.00 MANUAL

                            ENHANCE DEMO VERSION

                                 Dave Acre

                              U S E R W A R E

                              22 October 1996





      ABOUT USERWARE

        It's the name I've sort of associated with the programs I write.  I
        look for holes in what the industry has to offer, my needs, and
        design something to meet it with just the right amount of
        functionality.  Results: UserWare.


      WHO WILL USE THE ENHANCE PROGRAM

        I'm a programmer (engineer), and I like anything to make boring
        text appear non-boring.  I read a lot of email, other programs in
        different languages, text-based documents, and such.  I was looking
        for anything that could improve my ability to absorb information
        more rapidly.  I think you will like ENHANCE.  It lets YOU enhance
        whatever YOU want to see, any way YOU want.


     ABOUT ENHANCE

        This is the guide to the demo version of ENHANCE.  It can be
        identified by the version number presented by typing ENHDEMO at the
        DOS prompt and pressing enter.  The demo version only does simple
        enhancements, and only allows 5 keywords.  It will match words such
        as "and", but cannot look for " and ".  The full version, available
        for only $10 (during 1996), fully enables matching for words
        occurances such as " and " in the keyword file specification, and can
        handle up to 100 words.


      LIMITS

        From 1 to 100 (1 to 5 in the demo version) different strings
        may be defined with their own associated colors.  The timer
        interrupt searches VGA memory once each timer tick (1/18 second)
        for one keyword's presence and adjusts the text attributes on the
        screen.  If only 6 keywords are assigned, then the update rate for
        all 6 should be about 3 Hz (6/18).  Keyword lengths are limited to
        20 characters, and the fg and bg colors to 10.  The data in the
        keyword file must be entered as pure ASCII text.  Only 1 keyword
        assignment is allowed per line, and the line must be terminated
        with <cr><lf>.  The <cr> is a 0DH and the <lf> is a 0AH, which are
        the standard carriage return and linefeed ASCII characters.  Text
        not matched by ENHANCE will be unaffected in appearance.  Note
        that the error checking is very loose.  Just be sure each line has
        a keyword, a foreground color, and a background color all
        separated by space (0x20) delimiters.  .  See TABLE 1 for all
        colors possible.  Use the "." character as a "space specifier" for
        a keyword (except in the demo version).  To match " and " so
        the "and" in "sand" in not enhanced, use an entry like :
        
            .and.  +red black

        ENHANCE (the full version) will read in the keyword file and change
        all the "." (0x2E) to " " (0x20).  The "and" now requires that it be
        preceded and followed by a " " in order to be matched.



      TEXT RESOLUTION SUPPORT

        ENHANCE has been tested in all text modes from 40x25 to 132x43.  It
        reads the BIOS rows and columns to determine the extent of VGA memory
        it searches.  It needs about a 386-25 to perform reasonably well on
        an 80x25 text screen.  My 486-33 works fine on 132x43 screens.
        ENHANCE will flash a red "*" on the upper right of the screen if the
        55 msec TSR processing time is over 95% utilized performing text
        enhancements.


      ENTRY EXAMPLES

        Make any "hello" text found on the screen (in DOS mode) appear as
        bright red text on a white background:

            hello +red white<cr>


      TYPICAL USAGE

        I usually store the keyword file using a descriptive name with .KEY
        as the extension.  My file to ENHANCE a C program (while editing or
        viewing) is C.KEY.  Below is an example:

            if       +red      black
            else     +red      black
            case     +red      black
            while    +red      black
            /*       green     black
            */       green     black
            #define  +red      black
            static   bwhite    black 
            void     +green    black 
            char     +green    black 
            int      +green    black 
            unsigned +green    black 

        I then create a .BAT file with a descriptive name also.  Below is
        the one I use (LC.BAT) to view a C program in high resolution text
        mode using Vernon Buerg's shareware LIST program:

            rem ListC programs with ENHANCE
            hi
            mark
            enhance c.key
            list %1.c
            release
            low
            
        Note: HI.COM, LOW.COM, MARK.COM, and RELEASE.EXE are included with
        ENHANCE.  They have been freely available in the public domain for
        quite a few years.  HI forces the VGA card to 132x43 text mode (VESA
        mode 54).  LO sets it back to 80x25 (mode 03).  MARK sets a "mark" in
        memory.  ENHANCE gets loaded.  The user uses it.  The user then runs
        RELEASE to remove both ENHANCE and MARK from DOS memory.  They are
        free mid-1980's PC utilities programs.


      NEAT STUFF

        You can open a DOS window while running Windows 3.x, run ENHANCE
        (supplying you own keyword file), and the DOS text will be enhanced
        in much the same way as a normal full screen DOS session.  Open
        another DOS window, run ENHANCE again with a different keyword file.
        In this way you can run two completely different ENHANCing
        environments on one screen.

        MULTICOLOR FLASHING

        If a two copies of a keyword in the keyword file are separated by
        other words, the number of words determines the delay between that
        word being enhanced.

            .=.  red black
            other    green black
            other    green black
            other    green black
            other    green black
            other    green black
            other    green black
            other    green black
            other    green black
            .=.  blue black
            other    green black
            other    green black
            other    green black
            other    green black
            other    green black
            other    green black
            other    green black
            other    green black
        
        The above example will cause a text file to have the " = " occurances
        to be enhanced red, then "other" (for 8 1/18 sec ticks, then " = "
        enhanced blue, then "other" for 8 more 1/18 sec ticks.  The resulting
        effect can be quite interesting.  In this case the "=" will be red
        for 0.5 sec, and then blue for 0.5 sec, then red, and so on.  Some
        clever effects can be achieved.  Use your imagination.

      TABLE 1
    
        FOREGROUND_COLOR SPECIFIERS

            normal   blinking  bright   bright+blink
            color    bcolor    +color   +bcolor
        
            black    bblack    +black   +bblack
            blue     bblue     +blue    +bblue 
            green    bgreen    +green   +bgreen 
            cyan     bcyan     +cyan    +bcyan 
            red      bred      +red     +bred 
            magenta  bmagenta  +magenta +bmagenta 
            yellow   byellow   +yellow  +byellow 
            white    bwhite    +white   +bwhite 


        BACKGROUND_COLOR SPECIFIERS
        
            black 
            blue  
            green 
            cyan  
            red   
            magenta
            yellow
            white 
    

      KEYWORD FILE SYNTAX:  each line entry will appear as:

        keyword1  foreground_color  background_color<cr>
        :
        keywordn  foreground_color  background_color<cr>
    


      DEMO VERSUS FULL VERSION FEATURE COMPARISON CHART

                                    DEMO      FULL VERSION
                                    ----      ------------
        performs basic matches      Yes           Yes

        max number of keywords        5           100

        permits spaces in matches    No           Yes

        toggle enhancement ON/OFF    No           Yes

        selectable case sensitivity  No           Yes

        supported text resolution   
            40x25                   Yes           Yes
            80x25                   Yes           Yes
            80x43                    No           Yes
            132x43                   No           Yes




      HOW TO ORDER THE FULL VERSION

        Send a clean crisp $10 bill to me (no checks, and I will not return
        any received, and I won't send you any software).  What I will send
        to you is a 3.5" DSHD diskette with the latest version of ENHANCE,
        the manual on disk, example .KEY files, and a special program as a
        surprise.  See LICENSE.DOC for site licensing information.
        
        I promise no updates to the program, and make no guarantees about
        it's suitability to perform on all PC platforms.  I know it needs a
        platform faster than a 286-20 just to keep up (even in 80x25 text
        mode).
        
        Prices will go up in 1997.  

        Send a letter (and money too) to :


            Dave Acre
            11882 Wexford Place Drive
            Maryland Heights, MO  63043


        I appreciate comments.  Send some along.  Suggestions are also
        welcome.  I'll try to incorporate some of the best ones as time
        permits.  Please allow 4 weeks for delivery of your diskette.
        I'll typically do much better than this.


        Much thanks.  Dave.
            
